
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class SurveysDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const surveys = await db.surveys.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        url: data.url
        ||
        null
            ,
            
        detected_on: data.detected_on
        ||
        null
            ,
            
        form_schema: data.form_schema
        ||
        null
            ,
            
        page_context: data.page_context
        ||
        null
            ,
            
        language: data.language
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await surveys.setExtension( data.extension || null, {
            transaction,
        });
        

        

        

        return surveys;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const surveysData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                url: item.url
            ||
            null
            ,
            
                detected_on: item.detected_on
            ||
            null
            ,
            
                form_schema: item.form_schema
            ||
            null
            ,
            
                page_context: item.page_context
            ||
            null
            ,
            
                language: item.language
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const surveys = await db.surveys.bulkCreate(surveysData, { transaction });

        // For each item created, replace relation files
        

        return surveys;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const surveys = await db.surveys.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.url !== undefined) updatePayload.url = data.url;
        
        
        if (data.detected_on !== undefined) updatePayload.detected_on = data.detected_on;
        
        
        if (data.form_schema !== undefined) updatePayload.form_schema = data.form_schema;
        
        
        if (data.page_context !== undefined) updatePayload.page_context = data.page_context;
        
        
        if (data.language !== undefined) updatePayload.language = data.language;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await surveys.update(updatePayload, {transaction});

        
        
        if (data.extension !== undefined) {
            await surveys.setExtension(
              
              data.extension,
              
              { transaction }
            );
        }
        

        
        

        

        return surveys;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const surveys = await db.surveys.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of surveys) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of surveys) {
                await record.destroy({transaction});
            }
        });


        return surveys;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const surveys = await db.surveys.findByPk(id, options);

        await surveys.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await surveys.destroy({
            transaction
        });

        return surveys;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const surveys = await db.surveys.findOne(
            { where },
            { transaction },
        );

        if (!surveys) {
            return surveys;
        }

        const output = surveys.get({plain: true});

        
        
        
        
        
        
        
        
        output.fill_sessions_survey = await surveys.getFill_sessions_survey({
            transaction
        });
        
        
        
        
        
        
        
        output.extension = await surveys.getExtension({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.extensions,
        as: 'extension',
        
        where: filter.extension ? {
          [Op.or]: [
            { id: { [Op.in]: filter.extension.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.extension.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'surveys',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'surveys',
                        'url',
                        filter.url,
                    ),
                };
            }
            
            if (filter.form_schema) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'surveys',
                        'form_schema',
                        filter.form_schema,
                    ),
                };
            }
            

            
            

            
            if (filter.detected_onRange) {
                const [start, end] = filter.detected_onRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    detected_on: {
                    ...where.detected_on,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    detected_on: {
                    ...where.detected_on,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.page_context) {
                where = {
                    ...where,
                page_context: filter.page_context,
            };
            }
            
            if (filter.language) {
                where = {
                    ...where,
                language: filter.language,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.surveys.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'surveys',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.surveys.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

